package parsing;

import java.util.*;
import syntax.*;



public class Parsing 
{
	public static void connectSymbols(List<Tree<Header>> parseForest)
	{
		
	}
	

	
	public static List<Tree<Header>> getParseForest(String text)
	{
		List<Tree<Stream>> streams = getStreamForest(text);
		
		List<Tree<Header>> ptrees = BodyReader.readNormal(streams);
		
		
		return ptrees;
	}
	
	
	public static List<Tree<Stream>> getStreamForest(String text) 
	{
		String[] lines = text.split("\\r?\\n");
		Tree<Stream> root = new Tree<Stream>();
		buildSubTree(lines, root, 0, 0);

		return root.children;
	}


	/*
	 * This algorithm is a bit crap (inefficient) ...but since it is just a
	 * prototype where we don't care for speed, it's ok
	 * 
	 * return: the number of lines processed to build the tree
	 */
	private static int buildSubTree(String[] lines, Tree<Stream> root, int i, int indent)
	{			
		while (i < lines.length)
		{
			String str = lines[i];
			
			if (str.matches("[ \\t]*"))
			{
				i++;
				continue;
			}
			
			if (countTabs(str) < indent)
			{
				// this block is finished
				return i; // <- index of the less indented line
			}
			
			if (countTabs(str) == indent)
			{
				// add the line the current block
				Stream line = new Stream(str, i + 1);
				Tree<Stream> tree = new Tree<Stream>();
				tree.content = line.after(0); // to skip the white spaces
				root.children.add(tree);
					
				// and continue building that tree
				// the call may return instantly if there are no indented lines after
				i = buildSubTree(lines, tree, i + 1, indent + 1);
			}
			if (countTabs(str) > indent)
			{
				Stream line = new Stream(str, i + 1);
				throw new ParsingException(line, "Too much indentation!");
			}
		}
		
		return lines.length;
	}

	
	private static int countTabs(String str) 
	{
		int i = 0;
		while (i < str.length() && str.charAt(i) == '\t')
			i++;

		return i;
	}

}
