package parsing;


public class StreamHandler
{
	public static String grabToken(Stream stream)
	{
		String str = stream.str;

		if (str.length() == 0)
			throw new ParsingException(stream, "Unexpected end of line");
		
		char c = str.charAt(0);
		if (isDelimiter(c))
		{
			return Character.toString(c);
		}
		
		int i = 0;
		while (i < str.length() && isBreak(str.charAt(i)) == false)
			i++;
		
		return str.substring(0,i);
	}

	
	public static boolean isDelimiter(char c)
	{
		return (c == '.' | c == ',' | c == ';' | c == '(' | c == ')' | c == '[' | c == ']' | c == '{' | c == '}');
	}

	public static boolean isBreak(char c)
	{
		return (isDelimiter(c) | c == ' ' | c == '\t');
	}
}
