package syntax.expressions;
import java.util.*;


// built in operators
public class OpDef {
	
	int priority;
	
	String lhsType;
	String rhsType;
	String resType;
	
	OpDef(int priority, String lhsType, String rhsType,	String resType)
	{
		this.priority = priority;
		
		this.lhsType = lhsType;
		this.rhsType = rhsType;
		this.resType = resType;
	}


	static Hashtable<String, OpDef> operators = makeOperators();
	
	static Hashtable<String, OpDef> makeOperators()
	{
		Hashtable<String, OpDef> ops = new Hashtable<String, OpDef>();
		
		ops.put("&&", new OpDef(3, "Bool", "Bool", "Bool"));
		ops.put("||", new OpDef(3, "Bool", "Bool", "Bool"));
		
		ops.put("<", new OpDef(4, "Int", "Int", "Bool"));
		ops.put("<=", new OpDef(4, "Int", "Int", "Bool"));
		ops.put(">", new OpDef(4, "Int", "Int", "Bool"));
		ops.put(">=", new OpDef(4, "Int", "Int", "Bool"));
		
		ops.put("==", new OpDef(4, "?", "?", "Bool"));
		ops.put("><", new OpDef(4, "?", "?", "Bool"));
		
		ops.put("+", new OpDef(5, "Int", "Int", "Int"));
		ops.put("-", new OpDef(5, "Int", "Int", "Int"));
		ops.put("*", new OpDef(6, "Int", "Int", "Int"));
		ops.put("/", new OpDef(6, "Int", "Int", "Int"));
		ops.put("^", new OpDef(7, "Int", "Int", "Int"));
		
		ops.put("++", new OpDef(5, "String", "String", "String"));
		
		
		return ops;
	}
}
