package syntax.expressions;

import parsing.*;

import java.math.BigInteger;


public class VInt extends PrimitiveValue
{
	BigInteger val;

	public VInt(BigInteger val, SrcLoc start, SrcLoc end)
	{
		super ("Int", val.toByteArray(), start, end);

		this.val = val;
	}

	public static VInt read(Stream stream)
	{
		String num = StreamHandler.grabToken(stream);
		if (num.matches("-?[0-9]+"))
			return new VInt(new BigInteger(num, 10), stream.loc, stream.loc.after(num.length() - 1));
		else
			throw new ParsingException(stream, "Invalid integer");
	}




	public String toString()
	{
		return val.toString(10);
	}

}
