

import java.util.*;

import parsing.*;
import syntax.headers.*;
import syntax.expressions.*;

public class BodyReader
{
	enum BodyType {normal, cases};
	
	
	/**
	 * this is ugly, very ugly ...i know
	 */
	public static List<Tree<Header>> readNormal(List<Tree<Stream>> streams)
	{	
		List<Tree<Header>> ptrees = new LinkedList<Tree<Header>>();
		
		for(Tree<Stream> stree : streams)
		{
			BodyType type = BodyType.normal;
			
			Header h =  Header.read(stree.content);
			
			if (h instanceof Definition)
			{
				Definition def = (Definition) h;
				if (def.rhs instanceof CaseOf)
					type = BodyType.cases;
			}
			if (h instanceof CaseClause)
			{
				CaseClause cc = (CaseClause) h;
				if (cc.result instanceof CaseOf)
					type = BodyType.cases;
			}
			
			Tree<Header> ptree = new Tree<Header>();
			ptree.content = h;
			
			switch(type)
			{
			case normal:
				ptree.children = readNormal(stree.children);
				break;
			case cases:
				ptree.children = readCases(stree.children);
				break;
			default:
				throw new RuntimeException("Body type not implemented.");
			}
				
			ptrees.add(ptree);
		}
		
		return ptrees;
	}

	
	
	/**
	 * ...and here the twin brother
	 */
	public static List<Tree<Header>> readCases(List<Tree<Stream>> streams)
	{	
		List<Tree<Header>> ptrees = new LinkedList<Tree<Header>>();
		
		for(Tree<Stream> stree : streams)
		{
			BodyType type = BodyType.normal;
			
			CaseClause cc =  CaseClause.read(stree.content);
			

			if (cc.result instanceof CaseOf)
				type = BodyType.cases;
			
			Tree<Header> ptree = new Tree<Header>();
			ptree.content = cc;
			
			switch(type)
			{
			case normal:
				ptree.children = readNormal(stree.children);
				break;
			case cases:
				ptree.children = readCases(stree.children);
				break;
			default:
				throw new RuntimeException("Body type not implemented.");
			}
				
			ptrees.add(ptree);
		}
		
		return ptrees;
	}

}
